﻿Module Utils_UsefulFunctions

    Friend Function FormatSeconds(ByVal seconds As Double) As String
        If seconds >= 3600 Then
            Return Date.FromOADate(seconds / 86400).ToString("hh:mm:ss")
        ElseIf seconds >= 60 Then
            Return Date.FromOADate(seconds / 86400).ToString("mm:ss")
        Else
            Return CInt(seconds).ToString
        End If
    End Function

    ' -----------------------------------------------------------------
    '  ConvertFTP_ToArubaHTTP
    ' -----------------------------------------------------------------
    ' FROM: ftp://www.freetw.net/freetw.net/downloads/Backup_Livio/
    '   TO: http://www.freetw.net/downloads/Backup_Livio/
    ' -----------------------------------------------------------------
    ' FROM: ftp://www.theremino.com/www.theremino.com/files/
    '   TO: http://www.www.theremino.com/files/
    ' -----------------------------------------------------------------
    Friend Function ConvertFTP_ToArubaHTTP(ByVal ftp As String) As String
        Dim i1 As Int32 = InStr(ftp, "/")
        If i1 > 0 Then
            Dim i2 As Int32 = InStr(i1 + 1, ftp, "/")
            If i2 > 0 Then
                Dim i3 As Int32 = InStr(i2 + 1, ftp, "/")
                If i3 > 0 Then
                    Dim i4 As Int32 = InStr(i3 + 1, ftp, "/")
                    If i4 > 0 Then
                        Return "http:" & Strings.Mid(ftp, i1, i3 - i1) & Strings.Mid(ftp, i4)
                    End If
                End If
            End If
        End If
        Return ""
    End Function

    Friend Function RemoveLastFolderFromUrl(ByVal url As String) As String
        If Right(url, 1) = "/" Then
            url = url.Remove(url.Length - 1)
        End If

        Dim i As Int32 = InStrRev(url, "/")
        If i > 0 Then
            Return url.Remove(i)
        Else
            Return url
        End If
    End Function

    'Friend Function RemoveFileNameFromUrl(ByVal url As String) As String
    '    If Right(url, 1) = "/" Then
    '        Return url
    '    Else
    '        Dim i As Int32 = InStrRev(url, "/")
    '        If i > 0 Then
    '            Return url.Remove(i)
    '        Else
    '            Return url
    '        End If
    '    End If
    'End Function





    ' ======================================================================================================
    '  GET DROP DESTINATION PATH 
    ' ======================================================================================================

    Friend Function Get_DropDestinationPath() As String
        '
        Dim hwnd As Int32 = GetWindowUnderTheCursor()
        '
        If hwnd = Get_DesktopListView_Handle() Then

            'Debug.Print(Get_CursorPointedIcon_Info())

            ' -------------------------------------------------------- the handle is the Desktop
            If Get_CursorPointedIcon_Info() <> "" Then
                ' ---------------------------------------------------- the cursor is over a icon ( invalid destination ) 
                Return ""
            Else
                ' ---------------------------------------------------- the cursor is on the desktop
                Return GetDesktopPath()
            End If

        Else
            ' -------------------------------------------------------- the handle is a explorer window
            Return GetWindowsExplorerPath(hwnd)
        End If
    End Function


    ' ======================================================================================================
    '  Get_DesktopListView_Handle 
    ' ======================================================================================================

    Private Declare Function FindWindow Lib "user32" Alias "FindWindowA" (ByVal lpClassName As String, _
                                                                      ByVal lpWindowName As String) As Int32

    Private Declare Function FindWindowEx Lib "user32" Alias "FindWindowExA" (ByVal hWndParent As Int32, _
                                                                              ByVal hWndChildAfter As Integer, _
                                                                              ByVal lpClassName As String, _
                                                                              ByVal lpWindowName As String) As Int32
    Private Function Get_DesktopListView_Handle() As Int32
        Dim lHandle As Int32
        lHandle = FindWindow("Progman", vbNullString)
        lHandle = FindWindowEx(lHandle, 0, "SHELLDLL_defVIEW", vbNullString)
        Return FindWindowEx(lHandle, 0, "SysListView32", vbNullString)
    End Function


    Friend Function GetDesktopPath() As String
        Return Environment.GetFolderPath(Environment.SpecialFolder.Desktop) & "\"
    End Function


    ' ======================================================================================================
    '  GetWindowsExplorerPath 
    ' ======================================================================================================

    Private Declare Function GetParent Lib "user32" (ByVal hwnd As Int32) As Int32
    '
    ' --------------------------------------------------------------------------
    ' import the Com library "Microsoft Internet Controls" into the project
    ' --------------------------------------------------------------------------
    Private Function GetWindowsExplorerPath(ByVal hWnd As Int32) As String
        '
        For Each ie As SHDocVw.InternetExplorer In New SHDocVw.ShellWindowsClass
            '
            Dim testHwnd As Int32 = hWnd
            Do
                If ie.HWND = testHwnd Then
                    Dim filename As String
                    filename = IO.Path.GetFileNameWithoutExtension(ie.FullName).ToLower
                    If filename.Equals("explorer") Then
                        Dim url As String = ie.LocationURL
                        url = Strings.Mid(url, 6)
                        url = url.Replace("/", "\")
                        If url.StartsWith("\\\") Then url = Strings.Mid(url, 4)
                        url = url.Replace("%20", " ")
                        Return url & "\"
                    Else
                        Return ""
                    End If
                Else
                    testHwnd = GetParent(testHwnd)
                End If
            Loop Until testHwnd = 0
        Next
        Return ""
    End Function



    ' ======================================================================================================
    '  GetWindowUnderTheCursor
    ' ======================================================================================================

    Private Declare Function WindowFromPoint Lib "user32" (ByVal x As Int32, ByVal y As Int32) As Int32
    '
    Private Function GetWindowUnderTheCursor() As Int32
        Return WindowFromPoint(Cursor.Position.X, Cursor.Position.Y)
    End Function


    ' ======================================================================================================
    '  ASYNC KEY STATE
    ' ======================================================================================================

    Declare Function GetAsyncKeyState Lib "user32" (ByVal vKey As Int32) As Int16

    Private Const PRESSED_NOW As Int32 = &H8000
    Private Const PRESSED_AFTER_PREVIOUS_CALL As Int32 = &H1

    Public Function Key(ByVal k As Int32) As Boolean
        Key = (GetAsyncKeyState(k) And PRESSED_NOW) <> 0
    End Function

    Public Function KeyPrevious(ByVal k As Int32) As Boolean
        KeyPrevious = (GetAsyncKeyState(k) And PRESSED_AFTER_PREVIOUS_CALL) <> 0
    End Function

    Public Sub WaitMouseOff()
        While Key(Keys.LButton) Or Key(Keys.MButton) Or Key(Keys.RButton)
            SleepMyThread(1)
        End While
    End Sub

    Public Sub WaitKeyOff(ByVal WaitKey As Int32)
        Do
            SleepMyThread(1)
        Loop Until Not Key(WaitKey)
    End Sub



    ' ======================================================================================================
    '  SLEEP MY THREAD
    ' ======================================================================================================

    Public Sub SleepMyThread(ByVal TimeMillisec As Int32)
        System.Threading.Thread.Sleep(TimeMillisec)
    End Sub

End Module
